Upgrade Ruby on Rails to 4.1

08/22/2014 06:40 AM - Dominic Cleal

Status: Closed   

Priority: Normal   

Assignee: Daniel Lobato Garcia   

Category: Rails   

Target version: 1.11.0   

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request: https://github.com/theforeman/foreman/p

ull/2870,

https://github.com/theforeman/foreman-d

ocker/pull/126,

https://github.com/theforeman/foreman_

bootdisk/pull/18

  

Description

This ticket tracks the upgrade of core Foreman to Ruby on Rails 4.0 from 3.2.

Related issues:

Related to Foreman - Bug #10019: Compute Profile Memory options different for... Closed 04/03/2015

Related to Foreman - Bug #4274: remove I18n deprecation warning when running ... Resolved 02/06/2014

Related to Packaging - Bug #12876: Foreman build can't find bundler 1.3 or hi... Closed 12/18/2015

Related to Foreman - Bug #12891: search_by_params for host returns all hosts Closed 12/21/2015

Related to Foreman - Refactor #12892: move rails binaries to /bin directory Closed 12/21/2015

Related to Foreman - Bug #8055: missing stylesheets in apidoc Closed 10/23/2014

Related to Foreman - Bug #12977: sprockets-rails 2.2.2 or higher is needed fo... Closed 01/04/2016

Related to Foreman - Bug #13005: Plugin CSS assets are not minified during pr... Closed 01/05/2016

Related to Foreman - Bug #13033: plugin:gettext rake task doesn't load with g... Closed 01/07/2016

Related to Foreman - Bug #13131: plugin skip tests not working after rails 4 ... Closed 01/12/2016

Related to Foreman - Refactor #13409: Remove maintain_test_schema! Rails init... Closed 01/27/2016

Related to Foreman - Refactor #14022: secret_key_base should be configured Duplicate 03/02/2016

Related to Foreman - Bug #14028: Routing errors due to missing graphics/fonts... Closed 03/02/2016

Blocks Foreman - Tracker #3157: Rails 4.1 upgrade tasks Closed 09/27/2013

Blocks Foreman - Refactor #12485: Consider replacing Rails counter_cache with... Rejected 11/15/2015

Blocks Foreman - Feature #12873: Update Rails to 4.1.latest Closed 12/18/2015

Blocks Foreman - Bug #7246: Remove counter workaround for #5692 on upgrade to... Rejected 08/25/2014

Blocks Foreman - Bug #12219: Test failures on Ruby 2.2 Closed 10/20/2015

Associated revisions

Revision c80f3b10 - 12/11/2015 11:07 AM - Tom Caspy 

fixes #7230 - rails 4 compatibility

Revision fb9f45e8 - 12/18/2015 08:03 AM - Daniel Lobato Garcia

Fixes #7230, #12021 - Upgrade to Rails 4.1.5

This commits upgrades Rails to Rails 4.1.5. See a description of the

changes included here, and go to the pull request in GitHub to see more

detailed explanations:

Update gems to a Rails 4 compatible version, including dependencies

Fix counter cache columns

Remove conditions, order, limit from has_many relations
Remove test runner

On minitest 5, the runner API was deprecated, so our custom test

runner is no longer working.

Remove useless add_index on lookup_values match

An index is added previously on lookup_values :priority, and on Rails 4

rename_column changes 'priority' to 'match' already changes the name of

the index.

Alias assert_include to assert_includes.

Expire topbar cache

Subclass ApplicationMailer in test to avoid 'missing template' error

Fixes #12021 - Use .to_param to find parent object in LookupKeys controller

On Rails 4, .find will not default to .friendly.find so find_hostgroup,

find_environment and find_host will fail for non numeric IDs. However, we can

use from_param to find these objects. This is something we can do both on

Rails 3 and Rails 4, whereas using .friendly isn't an option until friendly_id

5.0, which depends on Rails 4.

Use explicit friendly ID search.

find_common finder uses from_param -> friendly -> find

The finder needed to be refactored because with the new Friendly ID we

have to use .friendly explicitely. It currently follows the strategy of

searching like this:

- from_param -> .friendly -> regular find

Remove RecordNotFound errors from parameterizable in rails 4

Protect attributes using attr_accessible and protected_attributes

url_for doesn't append port when protocol is specified

Some of our tests are checking if port 80 or 443 is included in the URL

generated by lib/foreman/renderer.rb. However url_for has changed in

Rails 4 and now it does not append the port even if explicitly added.   

If the protocol is specified, as it is in this case, then the url

generated will just have the protocol (http or https) but not the port

(80 or 443)

Validate object instead of _id column in join tables

On Rails 4 such validations will fail when we try to create objects

without explicitely assigning the id.

Puppetclass.new(:config_group => config_group) would fail even for a

valid config group, :config_group_id => config_group.id should be used

instead.   

To avoid that, we validate the object, not the ID column

Rails 4 non backwards compatible syntax changes

Changes that have to deal with how some of the internal Rails objects

need a new syntax, like generating routes, exceptions, form builders.

None of these are Rails 3 compatible.

Fixes #12199 - rails 4 migration errors

There are actually two parts to the issue of not being able to migrate

with this branch. The first is

 https://gist.github.com/eLobato/0f5db50b5c93cc6c277c and can be

temporarily fixed with rails/sass-rails#136 (comment) I am not sure of a

long term fix for that atm.   

Once that is patched, this error

 https://gist.github.com/johnpmitsch/96e5ba3629890931193a happens on a

migration. This will fix that error by changing the Migrator class

initializer arguments which have changed from rails 3 to rails 4

Refactor fact value test to not modify user_roles directly

Return external usergroupsas an array

Use eager_load to preload associations to be used in where

Fixes #7230, #12021 - Upgrade to Rails 4.1.5

This commits upgrades Rails to Rails 4.1.5. See a description of the

changes included here, and go to the pull request in GitHub to see more

detailed explanations:
Update gems to a Rails 4 compatible version, including dependencies

Fix counter cache columns

Remove conditions, order, limit from has_many relations

Remove test runner

On minitest 5, the runner API was deprecated, so our custom test

runner is no longer working.

Remove useless add_index on lookup_values match

An index is added previously on lookup_values :priority, and on Rails 4

rename_column changes 'priority' to 'match' already changes the name of

the index.

Alias assert_include to assert_includes.

Expire topbar cache

Subclass ApplicationMailer in test to avoid 'missing template' error

Fixes #12021 - Use .to_param to find parent object in LookupKeys controller

On Rails 4, .find will not default to .friendly.find so find_hostgroup,

find_environment and find_host will fail for non numeric IDs. However, we can

use from_param to find these objects. This is something we can do both on

Rails 3 and Rails 4, whereas using .friendly isn't an option until friendly_id

5.0, which depends on Rails 4.

Use explicit friendly ID search.

find_common finder uses from_param -> friendly -> find

The finder needed to be refactored because with the new Friendly ID we

have to use .friendly explicitely. It currently follows the strategy of

searching like this:

- from_param -> .friendly -> regular find

Remove RecordNotFound errors from parameterizable in rails 4

Protect attributes using attr_accessible and protected_attributes

url_for doesn't append port when protocol is specified

Some of our tests are checking if port 80 or 443 is included in the URL

generated by lib/foreman/renderer.rb. However url_for has changed in

Rails 4 and now it does not append the port even if explicitly added.   

If the protocol is specified, as it is in this case, then the url

generated will just have the protocol (http or https) but not the port

(80 or 443)

Validate object instead of _id column in join tables

On Rails 4 such validations will fail when we try to create objects

without explicitely assigning the id.

Puppetclass.new(:config_group => config_group) would fail even for a

valid config group, :config_group_id => config_group.id should be used

instead.   

To avoid that, we validate the object, not the ID column

Rails 4 non backwards compatible syntax changes

Changes that have to deal with how some of the internal Rails objects

need a new syntax, like generating routes, exceptions, form builders.

None of these are Rails 3 compatible.

Fixes #12199 - rails 4 migration errors

There are actually two parts to the issue of not being able to migrate

with this branch. The first is

 https://gist.github.com/eLobato/0f5db50b5c93cc6c277c and can be

temporarily fixed with rails/sass-rails#136 (comment) I am not sure of a

long term fix for that atm.   

Once that is patched, this error

 https://gist.github.com/johnpmitsch/96e5ba3629890931193a happens on a

migration. This will fix that error by changing the Migrator class

initializer arguments which have changed from rails 3 to rails 4

Refactor fact value test to not modify user_roles directly

Return external usergroupsas an array

Use eager_load to preload associations to be used in where

Auto detect jenkins rake task in application.rb and set test RAILS_ENV

in that case

Reference previously undigested assets in CSS and js as digested using
asset-url or image-url

Adapted sprockets manifest.json instead of manifest.yml (ehelms)

Revision 9df4a434 - 12/21/2015 10:08 AM - Dominic Cleal

refs #7230 - update Foreman dependencies

History

#1 - 08/22/2014 06:40 AM - Dominic Cleal

- Blocks Tracker #3157: Rails 4.1 upgrade tasks added

#2 - 10/01/2014 07:50 AM - Ohad Levy

- translation missing: en.field_release set to 21

#3 - 10/01/2014 08:50 AM - Ohad Levy

- translation missing: en.field_release deleted (21)

#4 - 12/16/2014 07:13 AM - Tom Caspy

- Status changed from New to Ready For Testing

- Assignee set to Tom Caspy

upgraded the gemfile on https://github.com/unorthodoxgeek/foreman/tree/rails4 - rails currently boots up. creating new tickets for fixing multiple issues

which popped up once that was done.

#5 - 10/28/2015 06:11 AM - The Foreman Bot

- Pull request https://github.com/theforeman/foreman/pull/2870 added

- Pull request deleted ()

#6 - 10/29/2015 11:16 AM - The Foreman Bot

- Assignee deleted (Tom Caspy)

#7 - 10/29/2015 11:39 AM - The Foreman Bot

- Assignee set to Tom Caspy

#8 - 11/15/2015 04:07 AM - Tomer Brisker

- Blocks Refactor #12485: Consider replacing Rails counter_cache with counter_culture gem added

#9 - 12/03/2015 10:18 AM - The Foreman Bot

- Pull request https://github.com/theforeman/foreman-docker/pull/126 added

#10 - 12/11/2015 07:01 AM - Anonymous

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset docker:foreman-docker|c80f3b10252f1303f34b3abfdfe35ad6f6e2011c.

#11 - 12/11/2015 07:08 AM - Dominic Cleal

- Status changed from Closed to Ready For Testing

- % Done changed from 100 to 0

This has not been merged to Foreman, a plugin commit erroneously "fixed" this ticket number.

#12 - 12/18/2015 04:57 AM - Dominic Cleal

- Subject changed from Upgrade Ruby on Rails to 4.0 to Upgrade Ruby on Rails to 4.1

- Assignee changed from Tom Caspy to Daniel Lobato Garcia

- translation missing: en.field_release set to 71
#13 - 12/18/2015 05:17 AM - Dominic Cleal

- Has duplicate Bug #4274: remove I18n deprecation warning when running tests added

#14 - 12/18/2015 05:17 AM - Dominic Cleal

- Has duplicate deleted (Bug #4274: remove I18n deprecation warning when running tests)

#15 - 12/18/2015 05:17 AM - Dominic Cleal

- Has duplicate Bug #4274: remove I18n deprecation warning when running tests added

#16 - 12/18/2015 05:21 AM - Dominic Cleal

- Related to Bug #10019: Compute Profile Memory options different for selected language? added

#17 - 12/18/2015 06:07 AM - Dominic Cleal

- Blocks Feature #12873: Update Rails to 4.1.latest added

#18 - 12/18/2015 06:12 AM - Dominic Cleal

- Blocks Bug #7246: Remove counter workaround for #5692 on upgrade to rails 4.x added

#19 - 12/18/2015 08:46 AM - Dominic Cleal

- Has duplicate deleted (Bug #4274: remove I18n deprecation warning when running tests)

#20 - 12/18/2015 08:46 AM - Dominic Cleal

- Related to Bug #4274: remove I18n deprecation warning when running tests added

#21 - 12/18/2015 09:01 AM - Daniel Lobato Garcia

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset fb9f45e819fbd15946084cd7cacd737dca5aa32e.

#22 - 12/18/2015 10:11 AM - Dominic Cleal

- Related to Bug #12876: Foreman build can't find bundler 1.3 or higher on Wheezy/Precise added

#23 - 12/21/2015 01:22 AM - Ori Rabin

- Related to Bug #12891: search_by_params for host returns all hosts added

#24 - 12/21/2015 07:02 AM - Ohad Levy

- Related to Refactor #12892: move rails binaries to /bin directory added

#25 - 12/22/2015 04:19 AM - Dominic Cleal

- Related to Bug #8055: missing stylesheets in apidoc added

#26 - 12/22/2015 06:15 AM - Dominic Cleal

- Blocks Bug #12219: Test failures on Ruby 2.2 added

#27 - 01/04/2016 04:13 AM - Dominic Cleal

- Related to Bug #12977: sprockets-rails 2.2.2 or higher is needed for production assets setup added

#28 - 01/05/2016 10:16 AM - Dominic Cleal

- Related to Bug #13005: Plugin CSS assets are not minified during precompilation added

#29 - 01/07/2016 03:51 AM - Dominic Cleal

- Related to Bug #13033: plugin:gettext rake task doesn't load with gettext_i18n_rails_js 1.x added

#30 - 01/12/2016 09:16 AM - The Foreman Bot

- Pull request https://github.com/theforeman/foreman_bootdisk/pull/18 added
#31 - 01/13/2016 03:26 AM - Dominic Cleal

- Related to Bug #13131: plugin skip tests not working after rails 4 migration added

#32 - 01/27/2016 09:49 AM - Dominic Cleal

- Related to Refactor #13409: Remove maintain_test_schema! Rails initializer added

#33 - 03/02/2016 10:42 AM - Dominic Cleal

- Related to Refactor #14022: secret_key_base should be configured added

#34 - 03/03/2016 03:29 AM - Dominic Cleal

- Related to Bug #14028: Routing errors due to missing graphics/fonts on navigating smart-proxy page added
